%define with_gcc_42 0
%define _default_patch_fuzz 2

Summary: GRand Unified Bootloader
Name: grub
Version: 0.97
Release: %mkrel 27
URL: http://www.gnu.org/software/grub/
Source0: ftp://alpha.gnu.org/gnu/grub/%{name}-%{version}.tar.gz
Source2: menu.lst.example
Patch10000: grub-0.5.96.1-ezd.patch
Patch10001: grub-0.97-gcc4_warnings.patch
Patch10005: grub-0.95-eltorito.patch
Patch10007: grub-0.91-nice-magic.patch
Patch10009: grub-0.95-mem_lower.patch
Patch10015: grub-0.97-install_sh.patch
Patch10018: grub-0.97-please-automake--add-AM_PROG_AS.patch
Patch10017: grub-gfxmenu-v8.diff
Patch1: grub-ext3-256byte-inode.patch
Patch22: grub-0.94-addsyncs.patch
Patch23: 0002-Add-strspn-strcspn-and-strtok_r.patch
Patch24: 0003-Allow-passing-multiple-image-files-to-the-initrd-com.patch
Patch25: grub-ext4-support.patch
Patch101: grub-0.97-once.patch
Patch102: grub-0.97-once-info-doc.patch
Patch500: grub-0.93-special-device-names.patch
Patch501: grub-0.94-i2o.patch
Patch502: grub-0.95-moreraid.patch
Patch505: grub-0.94-initrdmax.patch
Patch800: grub-0.95-odirect.patch
Patch801: grub-0.97-odirect-on-device-only.patch
Patch1000: grub-0.95-geometry-26kernel.patch
Patch1100: grub-0.95-md.patch
Patch1101: grub-0.97-md-rework--mdv-adapted.patch
Patch1104: grub-0.97-nxstack.patch
Patch1105: grub-0.97-nx-multiinstall.patch
Patch1110: grub-0.97-mdadm-path.patch
Patch1111: grub-0.95-md-mbr.patch
Patch1120: grub-0.95-nonmbr.patch
Patch1130: grub-0.95-recheck-bad.patch
Patch1135: grub-0.97-prototypes.patch
Patch1145: grub-0.97-dmraid.patch
Patch1146: grub-0.97-dmraid-recheck-bad--mdv-adapted.patch
Patch1147: grub-0.97-dmraid-partition-names.patch
Patch1148: grub-0.97-mactel-kbd.patch
Patch1150: grub-0.97-mpath.patch
Patch1154: grub-0.97-virtio-support.patch
Patch1151: grub-varargs.diff
Patch1152: grub-gpt.diff
Patch1153: grub-uuid.diff
Patch1155: grub-0.97-grub-build-id.patch
License: GPL
Group: System/Kernel and hardware
BuildRequires: autoconf2.5
BuildRequires: automake1.8
%if %{with_gcc_42}
BuildRequires: gcc4.2
%endif
BuildRequires: libgpm-devel
BuildRequires: libncurses-devel
BuildRequires: tetex-dvips
BuildRequires: tetex-latex
BuildRequires: texinfo
Requires(post): info-install
Requires(preun): info-install
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Exclusivearch: %ix86 x86_64 amd64 ia32e
Provides: bootloader

%description
GRUB is a GPLed bootloader intended to unify bootloading across x86
operating systems.  In addition to loading the Linux and *BSD kernels,
it implements the Multiboot standard, which allows for flexible loading
of multiple boot images (needed for modular kernels such as the GNU
Hurd).

%package doc
Summary: More documentation for grub
Group: Books/Computer books

%description doc
More documentation for grub

%prep
%setup -q

%patch1 -p1 -b .256byte-inode
%patch22 -p1 -b .addsync
%patch23 -p1 -b .string-functions
%patch24 -p1 -b .multiple-initrd
%patch25 -p1 -b .ext4
%patch101 -p1 -b .bootonce
%patch102 -p1 -b .bootonce-doc -z .pix
%patch500 -p1 -b .raid
%patch501 -p1 -b .i2o
%patch502 -p1 -b .moreraid
%patch505 -p1 -b .initrdmax
%patch800 -p1 -b .odirect
%patch801 -p1 -b .odirect-on-device-only
%patch1000 -p1 -b .26geom
%patch1100 -p1 -b .md
%patch1101 -p1 -b .md-rework
%patch1104 -p1 -b .nxstack
%patch1105 -p1 -b .nx-multiinstall
%patch1110 -p1 -b .mdadm-path
%patch1111 -p1 -b .md-mbr
%patch1120 -p1 -b .nonmbr
%patch1130 -p1 -b .recheck-bad
%patch1135 -p1 -b .prototypes
%patch1145 -p1 -b .dmraid
%patch1146 -p1 -b .dmraid-recheck-bad
%patch1147 -p1 -b .dmraid-partition-names
%patch1148 -p1 -b .mactel-kbd
%patch1150 -p1 -b .mpath
%patch1154 -p1 -b .virtio
%patch1151 -p1 -b .varargs
%patch1152 -p1 -b .gpt
%patch1153 -p1 -b .uuid
%patch1155 -p1
%patch10000 -p1
%patch10001 -p1
%patch10005 -p1
%patch10007 -p1
%patch10009 -p1
%patch10015 -p1
%patch10018 -p1
%patch10017 -p0

%build
# force building grub.info from grub.texi (since patches do not edit both)
rm docs/grub.info

autoreconf
%if %{with_gcc_42}
CC=%{_bindir}/gcc4.2 \
%endif
CFLAGS="-Os -g -fno-strict-aliasing -fno-stack-protector -fno-reorder-functions -Wl,--build-id=none" \
./configure --build=%{_target_platform} \
            --host=%{_host} \
            --target=%{_target} \
            --prefix=%{_prefix} \
            --exec-prefix=/ \
            --bindir=%{_bindir} \
            --mandir=%{_mandir} \
            --infodir=%{_infodir} \
            --disable-auto-linux-mem-opt
%make
make -C docs ps

%install
rm -rf %{buildroot}
%makeinstall_std
rm -f %{buildroot}/%{_infodir}/dir
install -d %{buildroot}/boot/grub
install -m 0644 %{_sourcedir}/menu.lst.example %{buildroot}/boot/grub

%clean
rm -rf %{buildroot}

%post

if [ -f /boot/grub/install.sh ]; then
	if [ -x /usr/sbin/detectloader ]; then
		LOADER=$(/usr/sbin/detectloader)
		if [ "$LOADER" = "GRUB" ]; then
			for file in /lib/grub/%{_arch}-%{_real_vendor}/*stage*; do
				cp -f $file /boot/grub/ || :
			done
			sh /boot/grub/install.sh > /dev/null
		fi
	fi
elif [ -e /boot/grub/menu.lst -a -e /boot/grub/stage2 ]; then
    # no install.sh, trying to get one

    # look for the device
    for DEVICE in `awk '{print "/dev/" $4}' /proc/partitions`; do
	if [ -b $DEVICE ]; then
	    echo "trying $DEVICE"
	    if /bin/dd if=$DEVICE bs=512 count=1 2>/dev/null | /bin/grep -q GRUB; then
		if [ -z "$BOOT" ]; then
		    BOOT=$DEVICE
		else
		    echo "oops, GRUB found on both $DEVICE and $BOOT"
		fi
	    fi
	fi
    done

    if [ -n "$BOOT" ]; then
	echo "installing grub on $BOOT"
	grub-install $BOOT
    else
	echo "can not find where GRUB is installed"
    fi
fi
%_install_info %{name}.info
%_install_info multiboot.info

%preun
%_remove_install_info %{name}.info
%_remove_install_info multiboot.info

%triggerun -- grub <= 0.97-1
mkdir -p /boot/grub/backup_stagefiles
mv /boot/grub/*stage* /boot/grub/backup_stagefiles/ >/dev/null 2>&1 || :

if [ -f /boot/grub/install.sh ]; then
	if [ -x /usr/sbin/detectloader ]; then
		LOADER=$(/usr/sbin/detectloader)
		if [ "$LOADER" = "GRUB" ]; then
			for file in /lib/grub/%{_arch}-%{_real_vendor}/*stage*; do
				cp -f $file /boot/grub/ || :
			done
			sh /boot/grub/install.sh > /dev/null
		fi
	fi
fi

%triggerpostun -- grub <= 0.97-1
if [ -d /boot/grub/backup_stagefiles ]; then
	for file in /boot/grub/backup_stagefiles/*stage*; do
		if [ ! -f "/boot/grub/`basename $file`" ]; then
			mv $file /boot/grub/ || :
		else
			rm -f $file;
		fi
	done
	rmdir /boot/grub/backup_stagefiles > /dev/null || :
fi

%files
%defattr(0644,root,root,0755)
/boot/grub
%{_infodir}/*
%{_mandir}/*/*
/lib/grub
%defattr(0755,root,root,0755)
%{_bindir}/mbchk
/sbin/grub*

%files doc
%defattr(0644,root,root,0755)
%doc AUTHORS BUGS ChangeLog docs/grub.ps docs/multiboot.ps NEWS README
%doc THANKS TODO



%changelog
* Wed Jun 08 2011 Texstar <texstar at gmail.com> 0.97-27pclos2011
- Correct problem with gfxboot qemu preview with grub installed in a mapped file
- Change CFLAGS to disable stack protector
- Use -Os, used by Fedora
- Replace ext4 patch with the one from Fedora
- Patches 23 / 24: allow to specify multiple initrd on a single boot
- add fedora patch to support virtio partitions

* Sun Aug 30 2009 johnnyblack <johnnyblack at inbox.com> 0.97-25pclos2009
- add fedora patch to support virtio partitions, fix #52397
- add patches from ubuntu:
  o add support for "uuid xxx" instead of "root (hdX,Y)"
  o add support GPT (from Marco Gerards)
  o add patch "varargs" (since some changes are used by uuid patch)

* Fri May 01 2009 johnnyblack <johnnyblack@inbox.com> 0.97-24pclos2009
- add suppport for ext4


